import * as Rx from 'rxjs';
export declare const State: {
    OK: string;
    ERROR: string;
};
export declare class QEntry<T> {
    created: Date;
    running: Date;
    retryAt: Date;
    completed: Date;
    executeCnt: number;
    task: Rx.Subject<T>;
    constructor(task: Rx.Subject<T>);
}
export interface QConfig {
    taskTimer?: number;
    reclaimTimeout?: number;
    retryWaitTime?: number;
    maxExecuteCnt?: number;
}
export interface LogMsg {
    level: string;
    parts: any[];
}
export declare class Queue<T> {
    q: Rx.Subject<QEntry<T>>;
    deadLetter: Rx.Subject<QEntry<T>>;
    qEntries: QEntry<T>[];
    inProcess: boolean;
    qTask: number;
    reclaimTimeout: number;
    taskTimer: number;
    retryWaitTime: number;
    maxExecuteCnt: number;
    private logger;
    constructor(logger: Rx.Subject<LogMsg>, argv: QConfig);
    stop(): Rx.Observable<void>;
    private action(qe);
    private processMemoryQ();
    push(action: Rx.Subject<T>): void;
}
export declare function start<T>(logger: Rx.Subject<LogMsg>, argv: any): Queue<T>;
export default Queue;
